--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity arbitrator_inst is 
        port (
              -- inputs:
                 signal HCOUNT : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VCOUNT : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal address_from_dma : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal chipselect : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal data_from_dma : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal data_ready_from_dma : IN STD_LOGIC;
                 signal read : IN STD_LOGIC;
                 signal reset : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal BLUE : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal GREEN : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal RED : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal SRAM_ADDR : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal SRAM_CE_N : OUT STD_LOGIC;
                 signal SRAM_DQ : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal SRAM_LB_N : OUT STD_LOGIC;
                 signal SRAM_OE_N : OUT STD_LOGIC;
                 signal SRAM_UB_N : OUT STD_LOGIC;
                 signal SRAM_WE_N : OUT STD_LOGIC;
                 signal busy_to_dma : OUT STD_LOGIC;
                 signal pixel_clock : OUT STD_LOGIC;
                 signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal waitrequest : OUT STD_LOGIC
              );
end entity arbitrator_inst;


architecture europa of arbitrator_inst is
component arbitrator is 
           port (
                 -- inputs:
                    signal HCOUNT : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VCOUNT : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal address_from_dma : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal data_from_dma : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal data_ready_from_dma : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal reset : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal BLUE : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal GREEN : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal RED : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal SRAM_ADDR : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal SRAM_CE_N : OUT STD_LOGIC;
                    signal SRAM_DQ : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal SRAM_LB_N : OUT STD_LOGIC;
                    signal SRAM_OE_N : OUT STD_LOGIC;
                    signal SRAM_UB_N : OUT STD_LOGIC;
                    signal SRAM_WE_N : OUT STD_LOGIC;
                    signal busy_to_dma : OUT STD_LOGIC;
                    signal pixel_clock : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal waitrequest : OUT STD_LOGIC
                 );
end component arbitrator;

                signal internal_BLUE :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_GREEN :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_RED :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_SRAM_ADDR :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal internal_SRAM_CE_N :  STD_LOGIC;
                signal internal_SRAM_LB_N :  STD_LOGIC;
                signal internal_SRAM_OE_N :  STD_LOGIC;
                signal internal_SRAM_UB_N :  STD_LOGIC;
                signal internal_SRAM_WE_N :  STD_LOGIC;
                signal internal_busy_to_dma :  STD_LOGIC;
                signal internal_pixel_clock :  STD_LOGIC;
                signal internal_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_waitrequest :  STD_LOGIC;

begin

  --the_arbitrator, which is an e_instance
  the_arbitrator : arbitrator
    port map(
      BLUE => internal_BLUE,
      GREEN => internal_GREEN,
      RED => internal_RED,
      SRAM_ADDR => internal_SRAM_ADDR,
      SRAM_CE_N => internal_SRAM_CE_N,
      SRAM_DQ => SRAM_DQ,
      SRAM_LB_N => internal_SRAM_LB_N,
      SRAM_OE_N => internal_SRAM_OE_N,
      SRAM_UB_N => internal_SRAM_UB_N,
      SRAM_WE_N => internal_SRAM_WE_N,
      busy_to_dma => internal_busy_to_dma,
      pixel_clock => internal_pixel_clock,
      readdata => internal_readdata,
      waitrequest => internal_waitrequest,
      HCOUNT => HCOUNT,
      VCOUNT => VCOUNT,
      address => address,
      address_from_dma => address_from_dma,
      chipselect => chipselect,
      clk => clk,
      data_from_dma => data_from_dma,
      data_ready_from_dma => data_ready_from_dma,
      read => read,
      reset => reset,
      write => write,
      writedata => writedata
    );


  --vhdl renameroo for output signals
  BLUE <= internal_BLUE;
  --vhdl renameroo for output signals
  GREEN <= internal_GREEN;
  --vhdl renameroo for output signals
  RED <= internal_RED;
  --vhdl renameroo for output signals
  SRAM_ADDR <= internal_SRAM_ADDR;
  --vhdl renameroo for output signals
  SRAM_CE_N <= internal_SRAM_CE_N;
  --vhdl renameroo for output signals
  SRAM_LB_N <= internal_SRAM_LB_N;
  --vhdl renameroo for output signals
  SRAM_OE_N <= internal_SRAM_OE_N;
  --vhdl renameroo for output signals
  SRAM_UB_N <= internal_SRAM_UB_N;
  --vhdl renameroo for output signals
  SRAM_WE_N <= internal_SRAM_WE_N;
  --vhdl renameroo for output signals
  busy_to_dma <= internal_busy_to_dma;
  --vhdl renameroo for output signals
  pixel_clock <= internal_pixel_clock;
  --vhdl renameroo for output signals
  readdata <= internal_readdata;
  --vhdl renameroo for output signals
  waitrequest <= internal_waitrequest;

end europa;

